#include"modexec.h"
#include"IEL_exec_info.h"
#include<unistd.h>
#include<stdlib.h>

extern char** environ;

int modexec(IEL_exec_info_t *exec_info) {
  int PID, status;
  int ret;
  int argc = IEL_ARGC(exec_info);
  char **argv = IEL_ARGV(exec_info);

  if(argc == 0) {
    fprintf(stderr, "IEL_EXEC: No file specified for exec.\n"
                    "IEL_EXEC: Check configuration file args array.\n"
                    "IEL_EXEC: Doing nothing...\n");
    return IEL_SUCCESS;
  }

  if((PID = fork()) == 0) {
    //child

    argv[argc] = NULL;
    ret = execvpe(argv[0], argv, environ);
    perror("execvpe");
    exit(1);
  } else {
    printf("Hello from parent\n");
    //parent
    while(wait(&status) != PID);

    if(status == 0) {
      printf("openDriverAM: SUCCESSFUL RUN [%s], Exit Code [%d], IN RANK ID - (%d) : DIR - (%d) \n", \
          argv[0], status, exec_info->IEL_rank, exec_info->module_rank);
    } else {
      printf(" =====> openDriverAM: FAILED run [%s] terminated with Exit code [%d], IN RANK ID - (%d) : DIR - (%d) \n", \
          argv[0], status, exec_info->IEL_rank, exec_info->module_rank);
    }
    fflush(stdout);
  }
  return IEL_SUCCESS;
}


